# Standards: 0.11
---

# 6.5 Ensure ntp is configured

- name: 6.5 Ensure ntp is installed
  apt:
    name: "{{ item }}"
    state: installed
  with_items:
    - ntp
  tags:
    - level-1
    - section-6
    - "6.5"
    - scored

- name: 6.5 - Check if ntp conf file exists
  stat:
    path: "{{ cis_ntp_conf_filename }}"
  register: ntp_6_5
  tags:
    - level-1
    - section-6
    - "6.5"
    - scored

- name: 6.5 Ensure ntp.conf is configured
  lineinfile:
    dest: "{{ cis_ntp_conf_filename }}"
    regexp: "^restrict -4 default*"
    line: "restrict -4 default kod nomodify notrap nopeer noquery"
  when: 
    - ntp_6_5 is defined
  tags:
    - level-1
    - section-6
    - "6.5"
    - scored

- name: 6.5 Ensure ntp.conf is configured
  lineinfile:
    dest: "{{ cis_ntp_conf_filename }}"
    regexp: "^restrict -6 default*"
    line: "restrict -6 default kod nomodify notrap nopeer noquery"
  when: 
    - ntp_6_5 is defined
  tags:
    - level-1
    - section-6
    - "6.5"
    - scored

- name: 6.5 Ensure ntp server is configured
  command: grep "^server\s+[a-zA-Z1-9]+" {{ cis_ntp_conf_filename }}
  register: grep_6_5
  failed_when: "grep_6_5.rc == 2"
  when: 
    - ntp_6_5 is defined
  tags:
    - level-1
    - section-6
    - "6.5"
    - scored

- name: 6.5 Ensure ntp server is configured
  fail:
    msg: "*** ACTION REQUIRED *** ntp server not set."
  when: 
    - ntp_6_5 is defined
    - grep_6_5 is not defined
    - fail_on_manual_remediation_actions
  tags:
    - level-1
    - section-6
    - "6.5"
    - scored

- name: 6.5 Ensure ntp server is configured
  debug:
    msg: "*** ACTION REQUIRED *** ntp server not set."
  when:
    - ntp_6_5 is defined
    - grep_6_5 is not defined
    - not fail_on_manual_remediation_actions
  tags:
    - level-1
    - section-6
    - "6.5"
    - scored
